void LOGGER_init__(LOGGER *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MSG,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->LEVEL,LOGLEVEL__INFO,retain)
  __INIT_VAR(data__->TRIG0,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void LOGGER_body__(LOGGER *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->TRIG,) && !(__GET_VAR(data__->TRIG0,)))) {
    #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
    #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)

   LogMessage(GetFbVar(LEVEL),(char*)GetFbVar(MSG, .body),GetFbVar(MSG, .len));
  
    #undef GetFbVar
    #undef SetFbVar
;
  };
  __SET_VAR(data__->,TRIG0,,__GET_VAR(data__->TRIG,));

  goto __end;

__end:
  return;
} // LOGGER_body__() 





void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(0, data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_EVAL_body__() 





void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(1,(PYTHON_EVAL*)(void*)data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_POLL_body__() 





void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->N,0,retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  PYTHON_EVAL_init__(&data__->PY_EVAL,retain);
  __INIT_VAR(data__->COUNTER,0,retain)
  __INIT_VAR(data__->ADD10_OUT,0,retain)
  __INIT_VAR(data__->EQ13_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->SEL15_OUT,0,retain)
  __INIT_VAR(data__->AND7_OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __SET_VAR(data__->,ADD10_OUT,,ADD__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->COUNTER,),
    (UINT)1));
  __SET_VAR(data__->,EQ13_OUT,,EQ__BOOL__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->N,),
    (UINT)__GET_VAR(data__->ADD10_OUT,)));
  __SET_VAR(data__->,SEL15_OUT,,SEL__UINT__BOOL__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (BOOL)__GET_VAR(data__->EQ13_OUT,),
    (UINT)__GET_VAR(data__->ADD10_OUT,),
    (UINT)0));
  __SET_VAR(data__->,COUNTER,,__GET_VAR(data__->SEL15_OUT,));
  __SET_VAR(data__->,AND7_OUT,,AND__BOOL__BOOL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (BOOL)__GET_VAR(data__->EQ13_OUT,),
    (BOOL)__GET_VAR(data__->TRIG,)));
  __SET_VAR(data__->PY_EVAL.,TRIG,,__GET_VAR(data__->AND7_OUT,));
  __SET_VAR(data__->PY_EVAL.,CODE,,__GET_VAR(data__->CODE,));
  PYTHON_EVAL_body__(&data__->PY_EVAL);
  __SET_VAR(data__->,ACK,,__GET_VAR(data__->PY_EVAL.ACK,));
  __SET_VAR(data__->,RESULT,,__GET_VAR(data__->PY_EVAL.RESULT,));

  goto __end;

__end:
  return;
} // PYTHON_GEAR_body__() 





static inline DWORD __WATERSUPPLIER_MOVE__DWORD__DWORD1(BOOL EN,
  DWORD IN,
  WATERSUPPLIER *data__)
{
  DWORD __res;
  BOOL __TMP_ENO = __GET_VAR(data__->MOVE237_ENO,);
  __res = MOVE__DWORD__DWORD(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->MOVE237_ENO,,__TMP_ENO);
  return __res;
}

static inline BOOL __WATERSUPPLIER_GT__BOOL__DWORD2(BOOL EN,
  UINT __PARAM_COUNT,
  DWORD IN1,
  DWORD IN2,
  WATERSUPPLIER *data__)
{
  BOOL __res;
  BOOL __TMP_ENO = __GET_VAR(data__->GT37_ENO,);
  __res = GT__BOOL__DWORD(EN,
    &__TMP_ENO,
    __PARAM_COUNT,
    IN1,
    IN2);
  __SET_VAR(,data__->GT37_ENO,,__TMP_ENO);
  return __res;
}

static inline DWORD __WATERSUPPLIER_MOVE__DWORD__DWORD3(BOOL EN,
  DWORD IN,
  WATERSUPPLIER *data__)
{
  DWORD __res;
  BOOL __TMP_ENO = __GET_VAR(data__->MOVE52_ENO,);
  __res = MOVE__DWORD__DWORD(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->MOVE52_ENO,,__TMP_ENO);
  return __res;
}

static inline BOOL __WATERSUPPLIER_GT__BOOL__DWORD4(BOOL EN,
  UINT __PARAM_COUNT,
  DWORD IN1,
  DWORD IN2,
  WATERSUPPLIER *data__)
{
  BOOL __res;
  BOOL __TMP_ENO = __GET_VAR(data__->GT40_ENO,);
  __res = GT__BOOL__DWORD(EN,
    &__TMP_ENO,
    __PARAM_COUNT,
    IN1,
    IN2);
  __SET_VAR(,data__->GT40_ENO,,__TMP_ENO);
  return __res;
}

static inline DWORD __WATERSUPPLIER_MOVE__DWORD__DWORD5(BOOL EN,
  DWORD IN,
  WATERSUPPLIER *data__)
{
  DWORD __res;
  BOOL __TMP_ENO = __GET_VAR(data__->MOVE64_ENO,);
  __res = MOVE__DWORD__DWORD(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->MOVE64_ENO,,__TMP_ENO);
  return __res;
}

static inline BOOL __WATERSUPPLIER_GT__BOOL__DWORD6(BOOL EN,
  UINT __PARAM_COUNT,
  DWORD IN1,
  DWORD IN2,
  WATERSUPPLIER *data__)
{
  BOOL __res;
  BOOL __TMP_ENO = __GET_VAR(data__->GT62_ENO,);
  __res = GT__BOOL__DWORD(EN,
    &__TMP_ENO,
    __PARAM_COUNT,
    IN1,
    IN2);
  __SET_VAR(,data__->GT62_ENO,,__TMP_ENO);
  return __res;
}

static inline DWORD __WATERSUPPLIER_MOVE__DWORD__DWORD7(BOOL EN,
  DWORD IN,
  WATERSUPPLIER *data__)
{
  DWORD __res;
  BOOL __TMP_ENO = __GET_VAR(data__->MOVE75_ENO,);
  __res = MOVE__DWORD__DWORD(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->MOVE75_ENO,,__TMP_ENO);
  return __res;
}

static inline BOOL __WATERSUPPLIER_GT__BOOL__DWORD8(BOOL EN,
  UINT __PARAM_COUNT,
  DWORD IN1,
  DWORD IN2,
  WATERSUPPLIER *data__)
{
  BOOL __res;
  BOOL __TMP_ENO = __GET_VAR(data__->GT81_ENO,);
  __res = GT__BOOL__DWORD(EN,
    &__TMP_ENO,
    __PARAM_COUNT,
    IN1,
    IN2);
  __SET_VAR(,data__->GT81_ENO,,__TMP_ENO);
  return __res;
}

static inline DWORD __WATERSUPPLIER_MOVE__DWORD__DWORD9(BOOL EN,
  DWORD IN,
  WATERSUPPLIER *data__)
{
  DWORD __res;
  BOOL __TMP_ENO = __GET_VAR(data__->MOVE89_ENO,);
  __res = MOVE__DWORD__DWORD(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->MOVE89_ENO,,__TMP_ENO);
  return __res;
}

static inline BOOL __WATERSUPPLIER_GT__BOOL__DWORD10(BOOL EN,
  UINT __PARAM_COUNT,
  DWORD IN1,
  DWORD IN2,
  WATERSUPPLIER *data__)
{
  BOOL __res;
  BOOL __TMP_ENO = __GET_VAR(data__->GT95_ENO,);
  __res = GT__BOOL__DWORD(EN,
    &__TMP_ENO,
    __PARAM_COUNT,
    IN1,
    IN2);
  __SET_VAR(,data__->GT95_ENO,,__TMP_ENO);
  return __res;
}

static inline DWORD __WATERSUPPLIER_MOVE__DWORD__DWORD11(BOOL EN,
  DWORD IN,
  WATERSUPPLIER *data__)
{
  DWORD __res;
  BOOL __TMP_ENO = __GET_VAR(data__->MOVE103_ENO,);
  __res = MOVE__DWORD__DWORD(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->MOVE103_ENO,,__TMP_ENO);
  return __res;
}

static inline BOOL __WATERSUPPLIER_GT__BOOL__DWORD12(BOOL EN,
  UINT __PARAM_COUNT,
  DWORD IN1,
  DWORD IN2,
  WATERSUPPLIER *data__)
{
  BOOL __res;
  BOOL __TMP_ENO = __GET_VAR(data__->GT109_ENO,);
  __res = GT__BOOL__DWORD(EN,
    &__TMP_ENO,
    __PARAM_COUNT,
    IN1,
    IN2);
  __SET_VAR(,data__->GT109_ENO,,__TMP_ENO);
  return __res;
}

static inline DWORD __WATERSUPPLIER_MOVE__DWORD__DWORD13(BOOL EN,
  DWORD IN,
  WATERSUPPLIER *data__)
{
  DWORD __res;
  BOOL __TMP_ENO = __GET_VAR(data__->MOVE117_ENO,);
  __res = MOVE__DWORD__DWORD(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->MOVE117_ENO,,__TMP_ENO);
  return __res;
}

static inline BOOL __WATERSUPPLIER_GT__BOOL__DWORD14(BOOL EN,
  UINT __PARAM_COUNT,
  DWORD IN1,
  DWORD IN2,
  WATERSUPPLIER *data__)
{
  BOOL __res;
  BOOL __TMP_ENO = __GET_VAR(data__->GT123_ENO,);
  __res = GT__BOOL__DWORD(EN,
    &__TMP_ENO,
    __PARAM_COUNT,
    IN1,
    IN2);
  __SET_VAR(,data__->GT123_ENO,,__TMP_ENO);
  return __res;
}

static inline DWORD __WATERSUPPLIER_MOVE__DWORD__DWORD15(BOOL EN,
  DWORD IN,
  WATERSUPPLIER *data__)
{
  DWORD __res;
  BOOL __TMP_ENO = __GET_VAR(data__->MOVE131_ENO,);
  __res = MOVE__DWORD__DWORD(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->MOVE131_ENO,,__TMP_ENO);
  return __res;
}

static inline BOOL __WATERSUPPLIER_GT__BOOL__DWORD16(BOOL EN,
  UINT __PARAM_COUNT,
  DWORD IN1,
  DWORD IN2,
  WATERSUPPLIER *data__)
{
  BOOL __res;
  BOOL __TMP_ENO = __GET_VAR(data__->GT137_ENO,);
  __res = GT__BOOL__DWORD(EN,
    &__TMP_ENO,
    __PARAM_COUNT,
    IN1,
    IN2);
  __SET_VAR(,data__->GT137_ENO,,__TMP_ENO);
  return __res;
}

static inline DWORD __WATERSUPPLIER_MOVE__DWORD__DWORD17(BOOL EN,
  DWORD IN,
  WATERSUPPLIER *data__)
{
  DWORD __res;
  BOOL __TMP_ENO = __GET_VAR(data__->MOVE145_ENO,);
  __res = MOVE__DWORD__DWORD(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->MOVE145_ENO,,__TMP_ENO);
  return __res;
}

static inline BOOL __WATERSUPPLIER_GT__BOOL__DWORD18(BOOL EN,
  UINT __PARAM_COUNT,
  DWORD IN1,
  DWORD IN2,
  WATERSUPPLIER *data__)
{
  BOOL __res;
  BOOL __TMP_ENO = __GET_VAR(data__->GT151_ENO,);
  __res = GT__BOOL__DWORD(EN,
    &__TMP_ENO,
    __PARAM_COUNT,
    IN1,
    IN2);
  __SET_VAR(,data__->GT151_ENO,,__TMP_ENO);
  return __res;
}

static inline DWORD __WATERSUPPLIER_MOVE__DWORD__DWORD19(BOOL EN,
  DWORD IN,
  WATERSUPPLIER *data__)
{
  DWORD __res;
  BOOL __TMP_ENO = __GET_VAR(data__->MOVE159_ENO,);
  __res = MOVE__DWORD__DWORD(EN,
    &__TMP_ENO,
    IN);
  __SET_VAR(,data__->MOVE159_ENO,,__TMP_ENO);
  return __res;
}

void WATERSUPPLIER_init__(WATERSUPPLIER *data__, BOOL retain) {
  __INIT_VAR(data__->CURRENTTIMEDT,0,retain)
  __INIT_VAR(data__->CURRENTTIMETOD,0,retain)
  __INIT_VAR(data__->SUPPLYTIME,0,retain)
  __INIT_VAR(data__->NOOFSUPPLY,0,retain)
  __INIT_VAR(data__->TIMEMONITOR,0,retain)
  __INIT_VAR(data__->CURRENTNO,0,retain)
  __INIT_VAR(data__->TESTSW,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->SVMONPL,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->READYTIMEPL,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->VALVRELAY1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->VALVRELAY2,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->VALVRELAY3,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->READYTIME,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->READYTOCOMPARE,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->FLICK05_1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->FLICK05_2,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->FLICK05,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->N1SUPPLY,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->N2SUPPLY,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->N3SUPPLY,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->N4SUPPLY,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->N5SUPPLY,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->N6SUPPLY,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->N7SUPPLY,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->N8SUPPLY,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->N9SUPPLY,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->SUPPLYTRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->INSUPPLY,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CNTEND,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->VALVEON,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->VALVEUP,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CNTEND1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->INTERVAL,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->INTERVALUP,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TESTMODE,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TESTTRIGER,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->NEXTINTERVAL1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->NEXTTRIGER,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->DRVVALV0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->DRVVALV1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->DRVVALV2,__BOOL_LITERAL(FALSE),retain)
  TON_init__(&data__->TON0,retain);
  TON_init__(&data__->TON1,retain);
  TON_init__(&data__->TON2,retain);
  CTD_init__(&data__->CTD0,retain);
  TON_init__(&data__->TON3,retain);
  TON_init__(&data__->TON4,retain);
  TON_init__(&data__->TON5,retain);
  R_TRIG_init__(&data__->R_TRIG1,retain);
  __INIT_VAR(data__->MOVE237_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MOVE237_OUT,0,retain)
  __INIT_VAR(data__->LWORD_TO_DT8_OUT,__dt_to_timespec(0, 0, 0, 1, 1, 1970),retain)
  __INIT_VAR(data__->DATE_AND_TIME_TO_TIME_OF_DAY9_OUT,__tod_to_timespec(0, 0, 0),retain)
  __INIT_VAR(data__->TOD_TO_DWORD10_OUT,0,retain)
  __INIT_VAR(data__->DWORD_TO_WORD273_OUT,0,retain)
  __INIT_VAR(data__->GT37_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->GT37_OUT,__BOOL_LITERAL(FALSE),retain)
  R_TRIG_init__(&data__->R_TRIG2,retain);
  __INIT_VAR(data__->MOVE52_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MOVE52_OUT,0,retain)
  __INIT_VAR(data__->GT40_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->GT40_OUT,__BOOL_LITERAL(FALSE),retain)
  R_TRIG_init__(&data__->R_TRIG3,retain);
  __INIT_VAR(data__->MOVE64_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MOVE64_OUT,0,retain)
  __INIT_VAR(data__->GT62_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->GT62_OUT,__BOOL_LITERAL(FALSE),retain)
  R_TRIG_init__(&data__->R_TRIG4,retain);
  __INIT_VAR(data__->MOVE75_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MOVE75_OUT,0,retain)
  __INIT_VAR(data__->GT81_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->GT81_OUT,__BOOL_LITERAL(FALSE),retain)
  R_TRIG_init__(&data__->R_TRIG5,retain);
  __INIT_VAR(data__->MOVE89_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MOVE89_OUT,0,retain)
  __INIT_VAR(data__->GT95_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->GT95_OUT,__BOOL_LITERAL(FALSE),retain)
  R_TRIG_init__(&data__->R_TRIG6,retain);
  __INIT_VAR(data__->MOVE103_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MOVE103_OUT,0,retain)
  __INIT_VAR(data__->GT109_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->GT109_OUT,__BOOL_LITERAL(FALSE),retain)
  R_TRIG_init__(&data__->R_TRIG7,retain);
  __INIT_VAR(data__->MOVE117_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MOVE117_OUT,0,retain)
  __INIT_VAR(data__->GT123_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->GT123_OUT,__BOOL_LITERAL(FALSE),retain)
  R_TRIG_init__(&data__->R_TRIG8,retain);
  __INIT_VAR(data__->MOVE131_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MOVE131_OUT,0,retain)
  __INIT_VAR(data__->GT137_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->GT137_OUT,__BOOL_LITERAL(FALSE),retain)
  R_TRIG_init__(&data__->R_TRIG9,retain);
  __INIT_VAR(data__->MOVE145_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MOVE145_OUT,0,retain)
  __INIT_VAR(data__->GT151_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->GT151_OUT,__BOOL_LITERAL(FALSE),retain)
  R_TRIG_init__(&data__->R_TRIG10,retain);
  __INIT_VAR(data__->MOVE159_ENO,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MOVE159_OUT,0,retain)
  R_TRIG_init__(&data__->R_TRIG11,retain);
  R_TRIG_init__(&data__->R_TRIG12,retain);
  R_TRIG_init__(&data__->R_TRIG13,retain);
  R_TRIG_init__(&data__->R_TRIG14,retain);
  R_TRIG_init__(&data__->R_TRIG15,retain);
  R_TRIG_init__(&data__->R_TRIG16,retain);
  R_TRIG_init__(&data__->R_TRIG17,retain);
  R_TRIG_init__(&data__->R_TRIG18,retain);
  R_TRIG_init__(&data__->R_TRIG19,retain);
  R_TRIG_init__(&data__->R_TRIG20,retain);
  R_TRIG_init__(&data__->R_TRIG21,retain);
  R_TRIG_init__(&data__->R_TRIG22,retain);
  R_TRIG_init__(&data__->R_TRIG23,retain);
  R_TRIG_init__(&data__->R_TRIG24,retain);
  R_TRIG_init__(&data__->R_TRIG25,retain);
  R_TRIG_init__(&data__->R_TRIG26,retain);
  __INIT_VAR(data__->DWORD_TO_TIME202_OUT,__time_to_timespec(1, 0, 0, 0, 0, 0),retain)
  R_TRIG_init__(&data__->R_TRIG27,retain);
  __INIT_VAR(data__->EQ288_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->EQ294_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->EQ305_OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void WATERSUPPLIER_body__(WATERSUPPLIER *data__) {
  // Initialise TEMP variables

  __SET_VAR(data__->TON0.,IN,,!(__GET_VAR(data__->TESTMODE,)));
  __SET_VAR(data__->TON0.,PT,,__time_to_timespec(1, 0, 300, 0, 0, 0));
  TON_body__(&data__->TON0);
  __SET_VAR(data__->,READYTIME,,__GET_VAR(data__->TON0.Q,));
  __SET_VAR(data__->TON2.,IN,,__GET_VAR(data__->TON0.Q,));
  __SET_VAR(data__->TON2.,PT,,__time_to_timespec(1, 0, 1, 0, 0, 0));
  TON_body__(&data__->TON2);
  __SET_VAR(data__->,READYTOCOMPARE,,__GET_VAR(data__->TON2.Q,));
  __SET_VAR(data__->,TESTMODE,,((!(__GET_VAR(data__->READYTIME,)) && __GET_VAR(data__->TESTSW,)) || __GET_VAR(data__->TESTMODE,)));
  __SET_VAR(data__->R_TRIG1.,CLK,,(__GET_VAR(data__->TESTMODE,) && __GET_VAR(data__->TESTSW,)));
  R_TRIG_body__(&data__->R_TRIG1);
  __SET_VAR(data__->,TESTTRIGER,,__GET_VAR(data__->R_TRIG1.Q,));
  __SET_VAR(data__->,MOVE237_OUT,,__WATERSUPPLIER_MOVE__DWORD__DWORD1(
    (BOOL)__GET_VAR(data__->TESTTRIGER,),
    (DWORD)60,
    data__));
  if (__GET_VAR(data__->MOVE237_ENO,)) {
    __SET_VAR(data__->,SUPPLYTIME,,__GET_VAR(data__->MOVE237_OUT,));
  };
  __SET_VAR(data__->TON1.,IN,,!(__GET_VAR(data__->FLICK05_1,)));
  __SET_VAR(data__->TON1.,PT,,__time_to_timespec(1, 500, 0, 0, 0, 0));
  TON_body__(&data__->TON1);
  __SET_VAR(data__->,FLICK05_1,,__GET_VAR(data__->TON1.Q,));
  __SET_VAR(data__->,FLICK05_2,,(__GET_VAR(data__->FLICK05,) && __GET_VAR(data__->FLICK05_1,)));
  __SET_VAR(data__->,FLICK05,,(!(__GET_VAR(data__->FLICK05_2,)) && ((!(__GET_VAR(data__->FLICK05,)) && __GET_VAR(data__->FLICK05_1,)) || __GET_VAR(data__->FLICK05,))));
  __SET_VAR(data__->,LWORD_TO_DT8_OUT,,LWORD_TO_DT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (LWORD)__GET_VAR(data__->CURRENTTIMEDT,)));
  __SET_VAR(data__->,DATE_AND_TIME_TO_TIME_OF_DAY9_OUT,,DATE_AND_TIME_TO_TIME_OF_DAY(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (DT)__GET_VAR(data__->LWORD_TO_DT8_OUT,)));
  __SET_VAR(data__->,TOD_TO_DWORD10_OUT,,TOD_TO_DWORD(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (TOD)__GET_VAR(data__->DATE_AND_TIME_TO_TIME_OF_DAY9_OUT,)));
  __SET_VAR(data__->,CURRENTTIMETOD,,__GET_VAR(data__->TOD_TO_DWORD10_OUT,));
  __SET_VAR(data__->,DWORD_TO_WORD273_OUT,,DWORD_TO_WORD(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (DWORD)__GET_VAR(data__->CURRENTTIMETOD,)));
  __SET_VAR(data__->,TIMEMONITOR,,__GET_VAR(data__->DWORD_TO_WORD273_OUT,));
  __SET_VAR(data__->,GT37_OUT,,__WATERSUPPLIER_GT__BOOL__DWORD2(
    (BOOL)__GET_VAR(data__->READYTIME,),
    (UINT)2,
    (DWORD)__GET_VAR(data__->CURRENTTIMETOD,),
    (DWORD)28800,
    data__));
  __SET_VAR(data__->,N1SUPPLY,,__GET_VAR(data__->GT37_OUT,));
  __SET_VAR(data__->R_TRIG2.,CLK,,__GET_VAR(data__->N1SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG2);
  __SET_VAR(data__->,MOVE52_OUT,,__WATERSUPPLIER_MOVE__DWORD__DWORD3(
    (BOOL)__GET_VAR(data__->R_TRIG2.Q,),
    (DWORD)60,
    data__));
  if (__GET_VAR(data__->MOVE52_ENO,)) {
    __SET_VAR(data__->,SUPPLYTIME,,__GET_VAR(data__->MOVE52_OUT,));
  };
  __SET_VAR(data__->,GT40_OUT,,__WATERSUPPLIER_GT__BOOL__DWORD4(
    (BOOL)__GET_VAR(data__->READYTIME,),
    (UINT)2,
    (DWORD)__GET_VAR(data__->CURRENTTIMETOD,),
    (DWORD)32400,
    data__));
  __SET_VAR(data__->,N2SUPPLY,,__GET_VAR(data__->GT40_OUT,));
  __SET_VAR(data__->R_TRIG3.,CLK,,__GET_VAR(data__->N2SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG3);
  __SET_VAR(data__->,MOVE64_OUT,,__WATERSUPPLIER_MOVE__DWORD__DWORD5(
    (BOOL)__GET_VAR(data__->R_TRIG3.Q,),
    (DWORD)60,
    data__));
  if (__GET_VAR(data__->MOVE64_ENO,)) {
    __SET_VAR(data__->,SUPPLYTIME,,__GET_VAR(data__->MOVE64_OUT,));
  };
  __SET_VAR(data__->,GT62_OUT,,__WATERSUPPLIER_GT__BOOL__DWORD6(
    (BOOL)__GET_VAR(data__->READYTIME,),
    (UINT)2,
    (DWORD)__GET_VAR(data__->CURRENTTIMETOD,),
    (DWORD)36000,
    data__));
  __SET_VAR(data__->,N3SUPPLY,,__GET_VAR(data__->GT62_OUT,));
  __SET_VAR(data__->R_TRIG4.,CLK,,__GET_VAR(data__->N3SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG4);
  __SET_VAR(data__->,MOVE75_OUT,,__WATERSUPPLIER_MOVE__DWORD__DWORD7(
    (BOOL)__GET_VAR(data__->R_TRIG4.Q,),
    (DWORD)240,
    data__));
  if (__GET_VAR(data__->MOVE75_ENO,)) {
    __SET_VAR(data__->,SUPPLYTIME,,__GET_VAR(data__->MOVE75_OUT,));
  };
  __SET_VAR(data__->,GT81_OUT,,__WATERSUPPLIER_GT__BOOL__DWORD8(
    (BOOL)__GET_VAR(data__->READYTIME,),
    (UINT)2,
    (DWORD)__GET_VAR(data__->CURRENTTIMETOD,),
    (DWORD)39600,
    data__));
  __SET_VAR(data__->,N4SUPPLY,,__GET_VAR(data__->GT81_OUT,));
  __SET_VAR(data__->R_TRIG5.,CLK,,__GET_VAR(data__->N4SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG5);
  __SET_VAR(data__->,MOVE89_OUT,,__WATERSUPPLIER_MOVE__DWORD__DWORD9(
    (BOOL)__GET_VAR(data__->R_TRIG5.Q,),
    (DWORD)120,
    data__));
  if (__GET_VAR(data__->MOVE89_ENO,)) {
    __SET_VAR(data__->,SUPPLYTIME,,__GET_VAR(data__->MOVE89_OUT,));
  };
  __SET_VAR(data__->,GT95_OUT,,__WATERSUPPLIER_GT__BOOL__DWORD10(
    (BOOL)__GET_VAR(data__->READYTIME,),
    (UINT)2,
    (DWORD)__GET_VAR(data__->CURRENTTIMETOD,),
    (DWORD)43200,
    data__));
  __SET_VAR(data__->,N5SUPPLY,,__GET_VAR(data__->GT95_OUT,));
  __SET_VAR(data__->R_TRIG6.,CLK,,__GET_VAR(data__->N5SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG6);
  __SET_VAR(data__->,MOVE103_OUT,,__WATERSUPPLIER_MOVE__DWORD__DWORD11(
    (BOOL)__GET_VAR(data__->R_TRIG6.Q,),
    (DWORD)60,
    data__));
  if (__GET_VAR(data__->MOVE103_ENO,)) {
    __SET_VAR(data__->,SUPPLYTIME,,__GET_VAR(data__->MOVE103_OUT,));
  };
  __SET_VAR(data__->,GT109_OUT,,__WATERSUPPLIER_GT__BOOL__DWORD12(
    (BOOL)__GET_VAR(data__->READYTIME,),
    (UINT)2,
    (DWORD)__GET_VAR(data__->CURRENTTIMETOD,),
    (DWORD)46800,
    data__));
  __SET_VAR(data__->,N6SUPPLY,,__GET_VAR(data__->GT109_OUT,));
  __SET_VAR(data__->R_TRIG7.,CLK,,__GET_VAR(data__->N6SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG7);
  __SET_VAR(data__->,MOVE117_OUT,,__WATERSUPPLIER_MOVE__DWORD__DWORD13(
    (BOOL)__GET_VAR(data__->R_TRIG7.Q,),
    (DWORD)300,
    data__));
  if (__GET_VAR(data__->MOVE117_ENO,)) {
    __SET_VAR(data__->,SUPPLYTIME,,__GET_VAR(data__->MOVE117_OUT,));
  };
  __SET_VAR(data__->,GT123_OUT,,__WATERSUPPLIER_GT__BOOL__DWORD14(
    (BOOL)__GET_VAR(data__->READYTIME,),
    (UINT)2,
    (DWORD)__GET_VAR(data__->CURRENTTIMETOD,),
    (DWORD)50400,
    data__));
  __SET_VAR(data__->,N7SUPPLY,,__GET_VAR(data__->GT123_OUT,));
  __SET_VAR(data__->R_TRIG8.,CLK,,__GET_VAR(data__->N7SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG8);
  __SET_VAR(data__->,MOVE131_OUT,,__WATERSUPPLIER_MOVE__DWORD__DWORD15(
    (BOOL)__GET_VAR(data__->R_TRIG8.Q,),
    (DWORD)120,
    data__));
  if (__GET_VAR(data__->MOVE131_ENO,)) {
    __SET_VAR(data__->,SUPPLYTIME,,__GET_VAR(data__->MOVE131_OUT,));
  };
  __SET_VAR(data__->,GT137_OUT,,__WATERSUPPLIER_GT__BOOL__DWORD16(
    (BOOL)__GET_VAR(data__->READYTIME,),
    (UINT)2,
    (DWORD)__GET_VAR(data__->CURRENTTIMETOD,),
    (DWORD)54000,
    data__));
  __SET_VAR(data__->,N8SUPPLY,,__GET_VAR(data__->GT137_OUT,));
  __SET_VAR(data__->R_TRIG9.,CLK,,__GET_VAR(data__->N8SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG9);
  __SET_VAR(data__->,MOVE145_OUT,,__WATERSUPPLIER_MOVE__DWORD__DWORD17(
    (BOOL)__GET_VAR(data__->R_TRIG9.Q,),
    (DWORD)240,
    data__));
  if (__GET_VAR(data__->MOVE145_ENO,)) {
    __SET_VAR(data__->,SUPPLYTIME,,__GET_VAR(data__->MOVE145_OUT,));
  };
  __SET_VAR(data__->,GT151_OUT,,__WATERSUPPLIER_GT__BOOL__DWORD18(
    (BOOL)__GET_VAR(data__->READYTIME,),
    (UINT)2,
    (DWORD)__GET_VAR(data__->CURRENTTIMETOD,),
    (DWORD)57600,
    data__));
  __SET_VAR(data__->,N9SUPPLY,,__GET_VAR(data__->GT151_OUT,));
  __SET_VAR(data__->R_TRIG10.,CLK,,__GET_VAR(data__->N9SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG10);
  __SET_VAR(data__->,MOVE159_OUT,,__WATERSUPPLIER_MOVE__DWORD__DWORD19(
    (BOOL)__GET_VAR(data__->R_TRIG10.Q,),
    (DWORD)60,
    data__));
  if (__GET_VAR(data__->MOVE159_ENO,)) {
    __SET_VAR(data__->,SUPPLYTIME,,__GET_VAR(data__->MOVE159_OUT,));
  };
  __SET_VAR(data__->R_TRIG11.,CLK,,__GET_VAR(data__->N1SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG11);
  __SET_VAR(data__->R_TRIG12.,CLK,,__GET_VAR(data__->N2SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG12);
  __SET_VAR(data__->R_TRIG13.,CLK,,__GET_VAR(data__->N3SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG13);
  __SET_VAR(data__->R_TRIG14.,CLK,,__GET_VAR(data__->N4SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG14);
  __SET_VAR(data__->R_TRIG15.,CLK,,__GET_VAR(data__->N5SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG15);
  __SET_VAR(data__->R_TRIG16.,CLK,,__GET_VAR(data__->N6SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG16);
  __SET_VAR(data__->R_TRIG17.,CLK,,__GET_VAR(data__->N7SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG17);
  __SET_VAR(data__->R_TRIG18.,CLK,,__GET_VAR(data__->N8SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG18);
  __SET_VAR(data__->R_TRIG19.,CLK,,__GET_VAR(data__->N9SUPPLY,));
  R_TRIG_body__(&data__->R_TRIG19);
  __SET_VAR(data__->,SUPPLYTRIG,,(__GET_VAR(data__->READYTOCOMPARE,) && ((((((((__GET_VAR(data__->R_TRIG11.Q,) || __GET_VAR(data__->R_TRIG12.Q,)) || __GET_VAR(data__->R_TRIG13.Q,)) || __GET_VAR(data__->R_TRIG14.Q,)) || __GET_VAR(data__->R_TRIG15.Q,)) || __GET_VAR(data__->R_TRIG16.Q,)) || __GET_VAR(data__->R_TRIG17.Q,)) || __GET_VAR(data__->R_TRIG18.Q,)) || __GET_VAR(data__->R_TRIG19.Q,))));
  __SET_VAR(data__->,INSUPPLY,,(!(__GET_VAR(data__->CNTEND1,)) && ((!(__GET_VAR(data__->INSUPPLY,)) && __GET_VAR(data__->SUPPLYTRIG,)) || __GET_VAR(data__->INSUPPLY,))));
  __SET_VAR(data__->R_TRIG20.,CLK,,__GET_VAR(data__->VALVEUP,));
  R_TRIG_body__(&data__->R_TRIG20);
  __SET_VAR(data__->R_TRIG21.,CLK,,__GET_VAR(data__->INSUPPLY,));
  R_TRIG_body__(&data__->R_TRIG21);
  __SET_VAR(data__->CTD0.,CD,,__GET_VAR(data__->R_TRIG20.Q,));
  __SET_VAR(data__->CTD0.,LD,,__GET_VAR(data__->R_TRIG21.Q,));
  __SET_VAR(data__->CTD0.,PV,,3);
  CTD_body__(&data__->CTD0);
  __SET_VAR(data__->,CNTEND,,__GET_VAR(data__->CTD0.Q,));
  __SET_VAR(data__->R_TRIG22.,CLK,,__GET_VAR(data__->CTD0.Q,));
  R_TRIG_body__(&data__->R_TRIG22);
  __SET_VAR(data__->,CNTEND1,,__GET_VAR(data__->R_TRIG22.Q,));
  __SET_VAR(data__->,CURRENTNO,,__GET_VAR(data__->CTD0.CV,));
  __SET_VAR(data__->R_TRIG23.,CLK,,__GET_VAR(data__->INSUPPLY,));
  R_TRIG_body__(&data__->R_TRIG23);
  __SET_VAR(data__->R_TRIG24.,CLK,,__GET_VAR(data__->TESTTRIGER,));
  R_TRIG_body__(&data__->R_TRIG24);
  __SET_VAR(data__->R_TRIG25.,CLK,,__GET_VAR(data__->INSUPPLY,));
  R_TRIG_body__(&data__->R_TRIG25);
  __SET_VAR(data__->R_TRIG26.,CLK,,__GET_VAR(data__->TESTTRIGER,));
  R_TRIG_body__(&data__->R_TRIG26);
  __SET_VAR(data__->,VALVEON,,(((__GET_VAR(data__->INSUPPLY,) && !(__GET_VAR(data__->VALVEUP,))) && (((!(__GET_VAR(data__->CNTEND,)) && (__GET_VAR(data__->INTERVALUP,) || __GET_VAR(data__->R_TRIG23.Q,))) || __GET_VAR(data__->R_TRIG24.Q,)) || __GET_VAR(data__->VALVEON,))) || ((__GET_VAR(data__->TESTMODE,) && !(__GET_VAR(data__->VALVEUP,))) && (((!(__GET_VAR(data__->CNTEND,)) && (__GET_VAR(data__->INTERVALUP,) || __GET_VAR(data__->R_TRIG25.Q,))) || __GET_VAR(data__->R_TRIG26.Q,)) || __GET_VAR(data__->VALVEON,)))));
  __SET_VAR(data__->,DWORD_TO_TIME202_OUT,,DWORD_TO_TIME(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (DWORD)__GET_VAR(data__->SUPPLYTIME,)));
  __SET_VAR(data__->TON3.,IN,,__GET_VAR(data__->VALVEON,));
  __SET_VAR(data__->TON3.,PT,,__GET_VAR(data__->DWORD_TO_TIME202_OUT,));
  TON_body__(&data__->TON3);
  __SET_VAR(data__->,VALVEUP,,__GET_VAR(data__->TON3.Q,));
  __SET_VAR(data__->R_TRIG27.,CLK,,__GET_VAR(data__->INSUPPLY,));
  R_TRIG_body__(&data__->R_TRIG27);
  __SET_VAR(data__->,INTERVAL,,((__GET_VAR(data__->INSUPPLY,) && !(__GET_VAR(data__->INTERVALUP,))) && ((!(__GET_VAR(data__->CNTEND,)) && (__GET_VAR(data__->NEXTTRIGER,) || __GET_VAR(data__->R_TRIG27.Q,))) || __GET_VAR(data__->INTERVAL,))));
  __SET_VAR(data__->TON4.,IN,,__GET_VAR(data__->INTERVAL,));
  __SET_VAR(data__->TON4.,PT,,__time_to_timespec(1, 0, 1200, 0, 0, 0));
  TON_body__(&data__->TON4);
  __SET_VAR(data__->,INTERVALUP,,__GET_VAR(data__->TON4.Q,));
  __SET_VAR(data__->,NEXTINTERVAL1,,((__GET_VAR(data__->INSUPPLY,) && !(__GET_VAR(data__->NEXTTRIGER,))) && (__GET_VAR(data__->INTERVALUP,) || __GET_VAR(data__->NEXTINTERVAL1,))));
  __SET_VAR(data__->TON5.,IN,,__GET_VAR(data__->NEXTINTERVAL1,));
  __SET_VAR(data__->TON5.,PT,,__time_to_timespec(1, 10, 0, 0, 0, 0));
  TON_body__(&data__->TON5);
  __SET_VAR(data__->,NEXTTRIGER,,__GET_VAR(data__->TON5.Q,));
  __SET_VAR(data__->,EQ288_OUT,,EQ__BOOL__INT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (INT)__GET_VAR(data__->CURRENTNO,),
    (INT)3));
  __SET_VAR(data__->,DRVVALV0,,__GET_VAR(data__->EQ288_OUT,));
  __SET_VAR(data__->,VALVRELAY1,,((__GET_VAR(data__->DRVVALV0,) || __GET_VAR(data__->TESTMODE,)) && __GET_VAR(data__->VALVEON,)));
  __SET_VAR(data__->,EQ294_OUT,,EQ__BOOL__INT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (INT)__GET_VAR(data__->CURRENTNO,),
    (INT)2));
  __SET_VAR(data__->,DRVVALV1,,__GET_VAR(data__->EQ294_OUT,));
  __SET_VAR(data__->,VALVRELAY2,,(__GET_VAR(data__->DRVVALV1,) && __GET_VAR(data__->VALVEON,)));
  __SET_VAR(data__->,EQ305_OUT,,EQ__BOOL__INT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (INT)__GET_VAR(data__->CURRENTNO,),
    (INT)1));
  __SET_VAR(data__->,DRVVALV2,,__GET_VAR(data__->EQ305_OUT,));
  __SET_VAR(data__->,VALVRELAY3,,(__GET_VAR(data__->DRVVALV2,) && __GET_VAR(data__->VALVEON,)));
  __SET_VAR(data__->,SVMONPL,,((__GET_VAR(data__->FLICK05,) && __GET_VAR(data__->INSUPPLY,)) || __GET_VAR(data__->VALVEON,)));
  __SET_VAR(data__->,READYTIMEPL,,((((__GET_VAR(data__->FLICK05,) && !(__GET_VAR(data__->TESTMODE,))) && !(__GET_VAR(data__->READYTIME,))) || (__GET_VAR(data__->FLICK05_1,) && __GET_VAR(data__->TESTMODE,))) || __GET_VAR(data__->READYTIME,)));

  goto __end;

__end:
  return;
} // WATERSUPPLIER_body__() 





